///--------------------------------------------------------------------------------------
//	SWFPSReport.c
//
//	Requires ALRT and DITL resource ID 200 to be copied from SpriteTest and put in 
//	your project. Remember to include the SWFPSReport.h file as well. It will 
//	call SysBeep if for some reason it can't display the alert.
//
//	Make sure to set the Sprite's move time and the MaxFPS rate to 0; otherwise 
//	the fps report will be innaccurate. (It still isn't terribly accurate, but should
//	give you a pretty good idea of how fast the animation is going.)
///--------------------------------------------------------------------------------------


#include "SWCommonHeaders.h"
#include "SWFPSReport.h"

#define	kNoteAlertID	200


unsigned long	frames;
long			ticks;

///--------------------------------------------------------------------------------------
//	Call StartTimer right before you start the animation
///--------------------------------------------------------------------------------------

SW_FUNC void	StartTimer( void )
{
	ticks = TickCount();
}


///--------------------------------------------------------------------------------------
//	Call ShowResults as soon as your animation is done and pass to it the number of
//	frames that have occured in the animation.
///--------------------------------------------------------------------------------------

SW_FUNC void	ShowResults( long frames )
{
	Str255 		framesString, secondsString, fpsString;
	long 		seconds, fps;
	
	seconds = ((TickCount() - ticks) / 60.15);

	NumToString(frames, framesString);
	NumToString(seconds, secondsString);

	fps = (seconds > 0) ? frames / seconds : frames;
	NumToString(fps, fpsString);

	ParamText(framesString, secondsString, fpsString, "\p");
	
	ShowCursor();
	
	if (NoteAlert(kNoteAlertID, NULL) == -1)
		SysBeep(10);
}

